#import "UPushPlugin.h"
#if __has_include(<u_push_plugin/u_push_plugin-Swift.h>)
#import <u_push_plugin/u_push_plugin-Swift.h>
#else
// Support project import fallback if the generated compatibility header
// is not copied when this plugin is created as a library.
// https://forums.swift.org/t/swift-static-libraries-dont-copy-generated-objective-c-header/19816
#import "u_push_plugin-Swift.h"
#endif

#import <UMCommon/UMCommon.h>
#import <UMPush/UMessage.h>
#import "MUPushManager.h"

@interface UPushPlugin()
@property(nonatomic,copy)NSString *deviceToken;
@property(nonatomic,strong)FlutterMethodChannel *channel;
@end


@implementation UPushPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
//  [SwiftUPushPlugin registerWithRegistrar:registrar];
    
    UPushPlugin *p = [[UPushPlugin alloc]init];
    
    
    FlutterMethodChannel *channel = [FlutterMethodChannel methodChannelWithName:@"u_push_plugin" binaryMessenger:[registrar messenger]];
    [registrar addApplicationDelegate:p];
    [registrar addMethodCallDelegate:p channel:channel];
}

-(void)handleMethodCall:(FlutterMethodCall *)call result:(FlutterResult)result{
    
    NSLog(@"bbbbbbb:%@",call);
    
    if([@"UMInitIOS" isEqualToString:call.method]){
        [MUPushManager UMInitWithMethodCall:call result:result];
       }else if([@"getCacheMessage" isEqualToString:call.method]){
          
       }else if([@"addTags" isEqualToString:call.method]){
           
       }
       else if([@"deleteTags" isEqualToString:call.method]){
           
       }else if([@"getTags" isEqualToString:call.method]){
           
       }
       else if([@"addAlias" isEqualToString:call.method]){
           
       }else if([@"deleteAlias" isEqualToString:call.method]){
           
       }
       else if([@"setAlias" isEqualToString:call.method]){
           
       }
       else if([@"getRegistrationId" isEqualToString:call.method]){
           
       }
       else if([@"UMSetBadgeClear" isEqualToString:call.method]){
           
       }else if([@"getDeviceToken" isEqualToString:call.method]){
           result(self.deviceToken);
        }else {
           result(FlutterMethodNotImplemented);
       }
       
}


#pragma mark - AppDelegate

- (BOOL)application:(UIApplication *)application
didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    
    //TODO: ios 程序杀死后 收到APNs推送 点击通知栏获取通知详细
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        if (launchOptions[UIApplicationLaunchOptionsRemoteNotificationKey]) {
            
            // 当被杀死状态收到本地通知时执行的跳转代码
            NSDictionary *remoteCotificationDic = [launchOptions objectForKey:UIApplicationLaunchOptionsRemoteNotificationKey];
            
            NSLog(@"离线消息推送点击通知栏");
            [self.channel invokeMethod:@"onReceiveOffLineNotification" arguments:remoteCotificationDic];
            
            
        }
    });
    
    
    
    
    // Push组件基本功能配置
    UMessageRegisterEntity * entity = [[UMessageRegisterEntity alloc] init];
    //type是对推送的几个参数的选择，可以选择一个或者多个。默认是三个全部打开，即：声音，弹窗，角标
    entity.types = UMessageAuthorizationOptionBadge|UMessageAuthorizationOptionSound|UMessageAuthorizationOptionAlert;
    if (@available(iOS 10.0, *)) {
        [UNUserNotificationCenter currentNotificationCenter].delegate=self;
    } else {
        // Fallback on earlier versions
    }
    [UMessage registerForRemoteNotificationsWithLaunchOptions:launchOptions Entity:entity     completionHandler:^(BOOL granted, NSError * _Nullable error) {
        if (granted) {
            NSLog(@"**********已经授权成功************");
        }else{
            NSLog(@"**********授权失败************");
        }
    }];
    
    
    
    
    return YES;
}
- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken{
    // 方式1
    
    NSMutableString *deviceTokenString = [NSMutableString string];
    
    const char *bytes = deviceToken.bytes;
    
    int iCount = deviceToken.length;
    
    for (int i = 0; i < iCount; i++) {
        
        [deviceTokenString appendFormat:@"%02x", bytes[i]&0x000000FF];
    }
    NSLog(@"deviceToken：%@", deviceTokenString);
    
    [UMessage registerDeviceToken: deviceToken];
    
    self.deviceToken=deviceTokenString;
    
    
    
}

//iOS10以下使用这两个方法接收通知，
-(void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo fetchCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler
{
    [UMessage setAutoAlert:NO];
    if([[[UIDevice currentDevice] systemVersion]intValue] < 10){
        [UMessage didReceiveRemoteNotification:userInfo];
        
        [_channel invokeMethod:@"onReceiveNotification" arguments:userInfo];
        completionHandler(UIBackgroundFetchResultNewData);
    }
}



//iOS10新增：处理前台收到通知的代理方法
-(void)userNotificationCenter:(UNUserNotificationCenter *)center willPresentNotification:(UNNotification *)notification withCompletionHandler:(void (^)(UNNotificationPresentationOptions))completionHandler{
    NSDictionary * userInfo = notification.request.content.userInfo;
    if([notification.request.trigger isKindOfClass:[UNPushNotificationTrigger class]]) {
        //应用处于前台时的远程推送接受
        //关闭U-Push自带的弹出框
        [UMessage setAutoAlert:NO];
        //必须加这句代码
        [UMessage didReceiveRemoteNotification:userInfo];
        
        NSLog(@"应用处于前台时的远程推送接受：%@", userInfo);
        
        
    }else{
        //应用处于前台时的本地推送接受
        NSLog(@"应用处于前台时的远程推送接受：%@", userInfo);
    }
    
    
    [self.channel invokeMethod:@"onReceiveNotification" arguments:userInfo];
    
    
    
    //当应用处于前台时提示设置，需要哪个可以设置哪一个
    completionHandler(UNNotificationPresentationOptionSound|UNNotificationPresentationOptionBadge|UNNotificationPresentationOptionAlert);
}

// iOS 10 以下点击本地通知
-(void)application:(UIApplication *)application didReceiveLocalNotification:(UILocalNotification *)notification {
    
    NSMutableDictionary *dic = [NSMutableDictionary dictionary];
    NSString *title = @"";
    if (@available(iOS 8.2, *)) {
        title = notification.alertTitle;
    } else {
        // Fallback on earlier versions
    }
    
    NSString *body = notification.alertBody;
    NSString *action = notification.alertAction;
    
    [dic setValue:title?:@"" forKey:@"title"];
    [dic setValue:body?:@"" forKey:@"body"];
    [dic setValue:action?:@"" forKey:@"action"];
    
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.channel invokeMethod:@"onNotificatiClickHandler" arguments:dic];
    });
}


//iOS10新增：处理后台点击通知的代理方法
-(void)userNotificationCenter:(UNUserNotificationCenter *)center didReceiveNotificationResponse:(UNNotificationResponse *)response withCompletionHandler:(void (^)())completionHandler{
    //    completionHandler();
    NSDictionary * userInfo = response.notification.request.content.userInfo;
    if([response.notification.request.trigger isKindOfClass:[UNPushNotificationTrigger class]]) {
        //应用处于后台时的远程推送接受
        //必须加这句代码
        [UMessage didReceiveRemoteNotification:userInfo];
        NSLog(@"应用处于后台时的远程推送接受：%@", userInfo);
        
    }else{
        //应用处于后台时的本地推送接受
        NSLog(@"应用处于后台时的本地推送接受：%@", userInfo);
    }
    
    
    UIApplicationState state = [UIApplication sharedApplication].applicationState;
    NSLog(@"应用处于后台时的本地推送接受：%ld", (long)state);
    
    if(state == UIApplicationStateBackground){
        
        NSLog(@"离线消息推送点击通知栏");
        [self.channel invokeMethod:@"onReceiveOffLineNotification" arguments:userInfo];
    }else if (state == UIApplicationStateInactive){
        
        NSLog(@"在线推送点击通知栏");
        [self.channel invokeMethod:@"onNotificatiClickHandler" arguments:userInfo];
    }
}


@end
